diff --git a/src/backend/utils/activity/wait_event_timing.c b/src/backend/utils/activity/wait_event_timing.c
index 0fd5092b268..1cfdb112411 100644
--- a/src/backend/utils/activity/wait_event_timing.c
+++ b/src/backend/utils/activity/wait_event_timing.c
@@ -788,118 +1001,898 @@ assign_wait_event_capture(int newval, void *extra)
 		INSTR_TIME_SET_ZERO(my_wait_event_timing->wait_start);
 		my_wait_event_timing->current_event = 0;
 	}
+
+	/*
+	 * Stepping down from TRACE: release the ~4 MB DSA ring now rather than
+	 * holding it pinned for the rest of the session.  Only fires when a ring
+	 * is actually attached, so OFF -> TRACE -> OFF without ever emitting a
+	 * trace record stays a no-op.  Re-enable re-allocates a fresh ring on the
+	 * first wait event via wait_event_trace_attach.  dsa_free is non-raising
+	 * LWLock bookkeeping, so it is safe from an assign hook.
+	 */
+	if (newval != WAIT_EVENT_CAPTURE_TRACE && my_wait_event_trace != NULL)
+		wait_event_trace_release_slot(my_trace_proc_number);
 }
 
+/* ================= Trace-level ring machinery ================= */
+
+
 /*
- * Out-of-line body for pgstat_report_wait_start()'s timing path.  Records
- * the start timestamp and the event being waited on.  Reached only when
- * wait_event_capture != OFF.
+ * Write a trace ring marker record.  Shared helper for all marker types.
  */
-void
-pgstat_report_wait_start_timing(uint32 wait_event_info)
+static void
+wait_event_trace_write_marker(uint8 record_type, int64 query_id)
 {
+	uint64		pos;
+	WaitEventTraceRecord *rec;
+	uint32		seq;
+	instr_time	now;
+
 	/*
-	 * Stay out of the timing path once proc_exit has begun tearing down DSA
-	 * mappings (see the before_shmem_exit callback).
+	 * Single capture-level gate: markers only land in the ring when
+	 * wait_event_capture is at TRACE.  This guarantees consistency with the
+	 * wait-event hot path (also gated on the same level) -- there is no
+	 * configuration in which one half of the trace fires and the other
+	 * doesn't.  query_id == 0 means "no query ID available" (utility command
+	 * or compute_query_id = off), which we skip.
+	 *
+	 * wait_event_trace_writes_disabled is the same per-backend gate the
+	 * wait-event hot path uses; it is raised by release_slot and
+	 * before_shmem_exit around slot-state transitions to keep both writers
+	 * consistent.  Markers cannot fire during those transitions today
+	 * (single-threaded execution, no nested executor), but checking here
+	 * keeps the contract uniform across all trace-ring writers and is robust
+	 * to future code paths that might invoke a marker from a nested context.
+	 *
+	 * No likely()/unlikely() annotation: this function is called at
+	 * query/exec boundaries (a handful per query, not per wait event), so
+	 * neither side of the branch dominates often enough for static layout to
+	 * matter, and the meaningful production configuration (wait_event_capture
+	 * = trace) is exactly when the body is hot -- an annotation on the
+	 * early-return would point the wrong way.
 	 */
-	if (wait_event_timing_writes_disabled)
+	if (wait_event_capture != WAIT_EVENT_CAPTURE_TRACE ||
+		wait_event_trace_writes_disabled ||
+		query_id == 0)
 		return;
 
-	if (my_wait_event_timing == NULL)
+	/*
+	 * Lazy attach on first use.  Allocation lives here (not in the assign
+	 * hook) because dsa_allocate_extended() can ereport(ERROR) on OOM, which
+	 * is forbidden in assign-hook context but legitimate here.  Idempotent:
+	 * wait_event_trace_attach() short-circuits on subsequent calls.
+	 */
+	if (my_wait_event_trace == NULL)
 	{
-		pgstat_wait_event_timing_lazy_attach();
+		if (my_trace_proc_number < 0)
+			return;
+		wait_event_trace_attach(my_trace_proc_number);
+		if (my_wait_event_trace == NULL)
+			return;				/* attach path unable to allocate */
+	}
 
-		/*
-		 * lazy_attach can dispatch nested wait events while it sets up DSA
-		 * (dsa_attach takes an internal LWLock); those nested wait_end calls
-		 * clear my_wait_event_info to 0.  Re-publish so the outer wait stays
-		 * visible in pg_stat_activity.  Only needed on the first-attach path.
-		 */
-		*(volatile uint32 *) my_wait_event_info = wait_event_info;
+	/*
+	 * Claim the next slot.  Single-writer counter (only the owning backend
+	 * writes its own ring), so a plain read+write is sufficient and avoids
+	 * the LOCK XADD that pg_atomic_fetch_add_u64 would emit -- a wasted
+	 * cache-coherence trip on an unshared cache line at this rate (one per
+	 * wait event).  Cross-backend readers use pg_atomic_read_u64, which
+	 * compiles to a plain MOV on x86 and tolerates concurrent writes here
+	 * (their actual safety against the records[] window is the per-record
+	 * seqlock below).  Same idiom as injection_point.c's per-entry generation
+	 * counter (single writer + multiple lock-free readers).
+	 */
+	pos = pg_atomic_read_u64(&my_wait_event_trace->write_pos);
+	pg_atomic_write_u64(&my_wait_event_trace->write_pos, pos + 1);
+	rec = &my_wait_event_trace->records[pos & my_wait_event_trace->ring_mask];
+	seq = (uint32) (pos * 2 + 1);
+
+	rec->seq = seq;
+	pg_write_barrier();			/* release: payload stores must not rise above
+								 * seq=odd */
+
+	INSTR_TIME_SET_CURRENT(now);
+	rec->record_type = record_type;
+	rec->timestamp_ns = INSTR_TIME_GET_NANOSEC(now);
+	rec->data.query.query_id = query_id;
+	rec->data.query.pad2 = 0;
+
+	pg_write_barrier();			/* release: payload stores must land before
+								 * seq=even */
+	rec->seq = seq + 1;
+}
+
+void
+wait_event_trace_query_start(int64 query_id)
+{
+	wait_event_trace_write_marker(TRACE_QUERY_START, query_id);
+}
+
+void
+wait_event_trace_query_end(int64 query_id)
+{
+	wait_event_trace_write_marker(TRACE_QUERY_END, query_id);
+}
+
+void
+wait_event_trace_exec_start(int64 query_id)
+{
+	wait_event_trace_write_marker(TRACE_EXEC_START, query_id);
+}
+
+void
+wait_event_trace_exec_end(int64 query_id)
+{
+	wait_event_trace_write_marker(TRACE_EXEC_END, query_id);
+}
+
+/*
+ * Report the shared memory space needed for trace ring buffer control.
+ * Only a small control struct is in fixed shmem; the actual ring buffers
+ * are allocated lazily via DSA.  At ~24 bytes/slot, the slot array adds
+ * ~26 KB at a default MaxBackends, negligible compared to the ring
+ * memory itself.
+ */
+static Size
+WaitEventTraceControlShmemSize(void)
+{
+	return add_size(offsetof(WaitEventTraceControl, trace_slots),
+					mul_size(NUM_WAIT_EVENT_TIMING_SLOTS,
+							 sizeof(WaitEventTraceSlot)));
+}
+
+static void
+WaitEventTraceControlShmemRequest(void *arg)
+{
+	ShmemRequestStruct(.name = "WaitEventTraceControl",
+					   .size = WaitEventTraceControlShmemSize(),
+					   .ptr = (void **) &WaitEventTraceCtl);
+}
+
+/*
+ * Initialize shared memory for trace ring buffer control.
+ */
+static void
+WaitEventTraceControlShmemInit(void *arg)
+{
+	int			i;
+
+	WaitEventTraceCtl->trace_dsa_handle = DSA_HANDLE_INVALID;
+	LWLockInitialize(&WaitEventTraceCtl->lock,
+					 LWTRANCHE_WAIT_EVENT_TRACE_DSA);
+	for (i = 0; i < NUM_WAIT_EVENT_TIMING_SLOTS; i++)
+	{
+		WaitEventTraceSlot *s = &WaitEventTraceCtl->trace_slots[i];
+
+		pg_atomic_init_u64(&s->generation, 0);
+		pg_atomic_init_u32(&s->state, WAIT_EVENT_TRACE_SLOT_FREE);
+		s->pad = 0;
+		s->ring_ptr = InvalidDsaPointer;
 	}
+}
 
-	if (my_wait_event_timing != NULL)
+const ShmemCallbacks WaitEventTraceControlShmemCallbacks = {
+	.request_fn = WaitEventTraceControlShmemRequest,
+	.init_fn = WaitEventTraceControlShmemInit,
+};
+
+/*
+ * Ensure the shared DSA for trace ring buffers exists and is attached.
+ * Creates it on first call (any backend), attaches on subsequent calls.
+ * Must be called from a backend context (not postmaster).
+ */
+static void
+wait_event_trace_ensure_dsa(void)
+{
+	MemoryContext oldcontext;
+
+	if (trace_dsa != NULL)
+		return;
+
+	oldcontext = MemoryContextSwitchTo(TopMemoryContext);
+
+	LWLockAcquire(&WaitEventTraceCtl->lock, LW_EXCLUSIVE);
+
+	if (WaitEventTraceCtl->trace_dsa_handle == DSA_HANDLE_INVALID)
 	{
-		INSTR_TIME_SET_CURRENT(my_wait_event_timing->wait_start);
-		my_wait_event_timing->current_event = wait_event_info;
+		trace_dsa = dsa_create(LWTRANCHE_WAIT_EVENT_TRACE_DSA);
+		dsa_pin(trace_dsa);
+		dsa_pin_mapping(trace_dsa);
+		WaitEventTraceCtl->trace_dsa_handle = dsa_get_handle(trace_dsa);
+	}
+	else
+	{
+		trace_dsa = dsa_attach(WaitEventTraceCtl->trace_dsa_handle);
+		dsa_pin_mapping(trace_dsa);
 	}
+
+	LWLockRelease(&WaitEventTraceCtl->lock);
+
+	MemoryContextSwitchTo(oldcontext);
 }
 
 /*
- * Out-of-line body for pgstat_report_wait_end()'s timing path.  Computes
- * the wait duration and accumulates per-event statistics.
+ * Transition our trace ring slot to ORPHANED on backend exit.
  *
- * capture_level is the value of wait_event_capture observed at the inline
- * gate; in this commit only STATS exists, so it is not branched on, but it
- * is threaded through to keep the gate ABI stable for the trace level
- * added later in the series.
+ * Registered as a before_shmem_exit callback.  Runs BEFORE
+ * dsm_backend_shutdown() detaches the DSA.
+ *
+ * Crucially, we do NOT free the ring here.  The ring stays allocated in
+ * DSA so that cross-backend consumers -- the in-tree
+ * pg_get_wait_event_trace SRF and any extension following the
+ * snapshot pattern documented on WaitEventTraceControl -- can read
+ * the dying backend's final waits.  The original "free at exit"
+ * design lost data the instant a worker terminated, which was
+ * particularly bad for parallel workers exiting in milliseconds at
+ * end-of-parallel-query.  See the lifecycle comment on
+ * WaitEventTraceControl for the full design
+ * rationale and the bounded-memory cost we accept in exchange.
+ *
+ * The ORPHANED slot is reclaimed in one of two ways:
+ *   (a) a new backend at this procNumber calls
+ *       wait_event_trace_clear_orphan_at_init() at backend init, or
+ *   (b) the DBA calls pg_stat_clear_orphaned_wait_event_rings().
+ *
+ * State transition order matters: bump generation BEFORE storing the
+ * new state, so cross-backend readers that snapshot
+ * (generation_before, state, ring_ptr, generation_after) under the
+ * lock see a consistent (state, ring_ptr) pair iff generation didn't
+ * change.  We hold the lock for the whole transition, but readers do
+ * not have to (they just take it briefly to snapshot the ring
+ * contents); the generation check is what makes the unlocked-read
+ * path safe.
  */
-void
-pgstat_report_wait_end_timing(int capture_level)
+static void
+wait_event_trace_before_shmem_exit(int code, Datum arg)
 {
-	uint32		event;
-	uint32		cur_reset_gen;
+	int			procNumber = DatumGetInt32(arg);
+	WaitEventTraceSlot *slot;
 
-	(void) capture_level;
+	if (WaitEventTraceCtl == NULL)
+		return;
 
-	if (wait_event_timing_writes_disabled)
+	if (procNumber < 0 || procNumber >= NUM_WAIT_EVENT_TIMING_SLOTS)
 		return;
 
-	if (my_wait_event_timing == NULL)
+	slot = &WaitEventTraceCtl->trace_slots[procNumber];
+
+	/*
+	 * If this backend never ended up with an OWNED slot (e.g. capture was off
+	 * the whole session, or the trace was released back to FREE via
+	 * assign_wait_event_capture going trace -> off), there is nothing to
+	 * transition.  Read state without the lock first as a fast-path check;
+	 * the authoritative re-check happens under the lock below.
+	 */
+	if (pg_atomic_read_u32(&slot->state) != WAIT_EVENT_TRACE_SLOT_OWNED)
 	{
-		pgstat_wait_event_timing_lazy_attach();
-		if (my_wait_event_timing == NULL)
-			return;
+		wait_event_trace_writes_disabled = true;
+		my_wait_event_trace = NULL;
+		return;
 	}
 
-	event = my_wait_event_timing->current_event;
+	/*
+	 * Disable trace-ring writes on this backend before we touch the lock.
+	 * Writes after this point would race with the OWNED -> ORPHANED state
+	 * publish below: a wait event whose end-timing path runs after the state
+	 * has been published as ORPHANED would write into a ring that the patch
+	 * contract declares read-only post-mortem.  Cross-backend readers
+	 * snapshot ORPHANED rings without expecting concurrent writes from the
+	 * dying owner.  See wait_event_trace_writes_disabled for the full UAF /
+	 * contract-violation analysis.
+	 *
+	 * The flag stays true for the remainder of this backend's life (we are in
+	 * proc_exit; there is no subsequent capture re-enable to handle), so we
+	 * do not reset it.
+	 */
+	wait_event_trace_writes_disabled = true;
+
+	LWLockAcquire(&WaitEventTraceCtl->lock, LW_EXCLUSIVE);
 
 	/*
-	 * Service a pending cross-backend reset request.  A single relaxed atomic
-	 * load; when the shared generation has advanced past the value we last
-	 * acted on, clear our own counters on behalf of the requester and record
-	 * the reset.  wait_start is left untouched so the in-flight measurement
-	 * still lands (in the freshly-zeroed counters), and current_event is
-	 * zeroed so external readers do not see stale state.
+	 * Drop the local pointer inside the lock-held region as a second line of
+	 * defense; the writes-disabled flag above is the primary gate.
 	 */
-	cur_reset_gen = pg_atomic_read_u32(&my_wait_event_timing->reset_generation);
-	if (cur_reset_gen != my_last_reset_generation)
+	my_wait_event_trace = NULL;
+
+	if (pg_atomic_read_u32(&slot->state) == WAIT_EVENT_TRACE_SLOT_OWNED &&
+		DsaPointerIsValid(slot->ring_ptr))
 	{
-		memset(my_wait_event_timing->events, 0,
-			   sizeof(my_wait_event_timing->events));
-		lwlock_timing_hash_clear(my_wait_event_timing);
-		my_wait_event_timing->reset_count++;
-		my_wait_event_timing->lwlock_overflow_count = 0;
-		my_wait_event_timing->flat_overflow_count = 0;
-		my_wait_event_timing->current_event = 0;
-		my_last_reset_generation = cur_reset_gen;
+		/*
+		 * Bump generation first so any reader that snapped the old generation
+		 * will detect the change on its post-read recheck and discard its
+		 * read.  Then publish the ORPHANED state. Keep ring_ptr valid -- the
+		 * data is what we want to preserve.
+		 */
+		pg_atomic_fetch_add_u64(&slot->generation, 1);
+		pg_atomic_write_u32(&slot->state, WAIT_EVENT_TRACE_SLOT_ORPHANED);
 	}
 
-	if (event != 0 && !INSTR_TIME_IS_ZERO(my_wait_event_timing->wait_start))
-	{
-		instr_time	now;
-		int64		duration_ns;
-		int			idx;
-		WaitEventTimingEntry *entry = NULL;
-		bool		warn_lwlock_overflow = false;
-		bool		warn_flat_overflow = false;
+	LWLockRelease(&WaitEventTraceCtl->lock);
+}
 
-		INSTR_TIME_SET_CURRENT(now);
-		duration_ns = INSTR_TIME_GET_NANOSEC(now) -
-			INSTR_TIME_GET_NANOSEC(my_wait_event_timing->wait_start);
+/*
+ * Allocate (or re-acquire) a trace ring buffer for this backend via DSA.
+ * Called when wait_event_capture is set to 'trace'.
+ *
+ * Slot state at entry will be one of:
+ *
+ *   FREE     fresh slot (or one cleared on this backend's init by
+ *            wait_event_trace_clear_orphan_at_init): allocate a new
+ *            ring, transition slot to OWNED, bump generation.
+ *
+ *   OWNED    we already attached earlier in this same backend's life
+ *            (e.g. user toggled capture trace->stats->trace; the
+ *            stats step calls wait_event_trace_release_slot which
+ *            transitions back to FREE, but our cached
+ *            my_wait_event_trace was cleared on the way down -- so
+ *            seeing OWNED here at attach time means a different
+ *            backend somehow ended up with this procNumber, which
+ *            cannot happen because procNumber is per-backend and a
+ *            single backend can only run one attach at a time.  We
+ *            still tolerate this state defensively by re-mapping the
+ *            existing ring rather than leaking a second allocation.
+ *
+ *   ORPHANED can never be observed here: a new backend's
+ *            pgstat_set_wait_event_timing_storage() called
+ *            wait_event_trace_clear_orphan_at_init() before any
+ *            wait-event capture path can run, so any prior orphan has
+ *            already been demoted to FREE.  Treated as a safety check
+ *            (Assert in debug builds).
+ */
+void
+wait_event_trace_attach(int procNumber)
+{
+	/*
+	 * Re-entrancy guard.  dsa_create / dsa_allocate_extended below can emit
+	 * wait events internally; those reach the lazy-attach hot path which
+	 * calls back into this function while we still hold
+	 * WaitEventTraceCtl->lock or are mid-allocation.  See the
+	 * function-local-static-bool pattern explainer on
+	 * wait_event_timing_attach_array.
+	 */
+	static bool in_attach = false;
+	static bool shmem_exit_registered = false;
+	WaitEventTraceSlot *slot;
+	dsa_pointer p;
+	WaitEventTraceState *ts;
+	uint32		state_now;
 
-		if (duration_ns < 0)
-			duration_ns = 0;
+	if (in_attach)
+		return;
 
-		idx = wait_event_timing_index(event);
+	if (WaitEventTraceCtl == NULL)
+		return;
 
-		/*
-		 * Single-writer hot path: each slot has exactly one writer (the
-		 * owning backend), and the SRF reader is lock-free, so no locking is
-		 * needed here.  Overflow WARNINGs are deferred to after the
-		 * bookkeeping so ereport() cannot recurse through a wait event while
-		 * counters are in an intermediate state.
-		 */
+	if (procNumber < 0 || procNumber >= NUM_WAIT_EVENT_TIMING_SLOTS)
+		return;
+
+	/*
+	 * Skip the attach if we are inside a critical section.  Below this point
+	 * we call dsa_create / dsa_attach / dsa_allocate_extended, all of which
+	 * can allocate memory via MemoryContextAlloc and Assert-fail on
+	 * "CritSectionCount == 0 || allowInCritSection". The very-first wait
+	 * event after wait_event_capture = trace can land inside a critical
+	 * section (e.g. a parallel worker scanning a heap page hits
+	 * BufferSetHintBits16 -> XLogSaveBufferForHint -> XLogInsert ->
+	 * LWLockAcquire, with the XLogInsert critical section open).
+	 *
+	 * Skipping here silently drops the in-flight wait event (it is not
+	 * traced) but keeps the backend alive.  The next wait event outside any
+	 * critical section will hit this function again and attach successfully.
+	 * See the matching guard in pgstat_wait_event_timing_lazy_attach.
+	 */
+	if (CritSectionCount > 0)
+		return;
+
+	/*
+	 * Skip the attach if MyProc is already on an LWLock wait queue.  We are
+	 * called from the wait-event hot path which fires AFTER LWLockQueueSelf
+	 * has set MyProc->lwWaiting; a nested LWLockAcquire on our internal lock
+	 * (via wait_event_trace_ensure_dsa) would PANIC at lwlock.c:1029. See the
+	 * matching guard in pgstat_wait_event_timing_lazy_ attach for the full
+	 * rationale.
+	 */
+	if (MyProc != NULL && MyProc->lwWaiting != LW_WS_NOT_WAITING)
+		return;
+
+	slot = &WaitEventTraceCtl->trace_slots[procNumber];
+
+	in_attach = true;
+	PG_TRY();
+	{
+		state_now = pg_atomic_read_u32(&slot->state);
+
+		/*
+		 * ORPHANED is normally impossible at attach time --
+		 * pgstat_set_wait_event_timing_storage() at backend init calls
+		 * wait_event_trace_clear_orphan_at_init() which demotes any inherited
+		 * orphan to FREE.  But there is one case where this backend can
+		 * legitimately observe its own slot in the ORPHANED state: after we
+		 * have already run wait_event_trace_before_shmem_exit()
+		 * (transitioning the slot to ORPHANED on exit), a later
+		 * before_shmem_exit callback (e.g. pgstat_io_flush_cb during
+		 * proc_exit shutdown) can contend on an LWLock that emits a wait
+		 * event, which calls pgstat_report_wait_end_timing() ->
+		 * wait_event_trace_attach() after my_wait_event_trace has been
+		 * cleared.  We must not re-attach in that case: we are dying, the
+		 * ring is now post-mortem data for cross-backend readers, and the
+		 * writer invariant must hold.  Skip the trace for any wait events
+		 * emitted after our own exit transition.
+		 */
+		if (state_now == WAIT_EVENT_TRACE_SLOT_ORPHANED)
+		{
+			/* PG_FINALLY below clears in_attach. */
+		}
+		else if (state_now == WAIT_EVENT_TRACE_SLOT_OWNED &&
+				 DsaPointerIsValid(slot->ring_ptr))
+		{
+			/* Already have a ring buffer; re-map to it. */
+			wait_event_trace_ensure_dsa();
+			my_wait_event_trace = dsa_get_address(trace_dsa, slot->ring_ptr);
+			my_trace_proc_number = procNumber;
+		}
+		else
+		{
+			Size		alloc_size;
+
+			wait_event_trace_ensure_dsa();
+
+			/*
+			 * Cache the cluster-wide ring size on first allocation in this
+			 * backend.  wait_event_trace_ring_size is PGC_POSTMASTER, so by
+			 * the time any backend reaches here, its boot value has been
+			 * committed by the GUC framework.  All rings in the postmaster
+			 * run share the same dimensions.
+			 */
+			if (WaitEventTraceRingSize == 0)
+				WaitEventTraceRingSize =
+					(uint32) wait_event_trace_ring_size * 1024U /
+					(uint32) sizeof(WaitEventTraceRecord);
+
+			alloc_size = offsetof(WaitEventTraceState, records) +
+				(Size) WaitEventTraceRingSize * sizeof(WaitEventTraceRecord);
+
+			p = dsa_allocate_extended(trace_dsa, alloc_size, DSA_ALLOC_ZERO);
+			ts = dsa_get_address(trace_dsa, p);
+			pg_atomic_init_u64(&ts->write_pos, 0);
+			ts->ring_mask = WaitEventTraceRingSize - 1;
+
+			LWLockAcquire(&WaitEventTraceCtl->lock, LW_EXCLUSIVE);
+
+			/*
+			 * Publish ring_ptr BEFORE transitioning state to OWNED.
+			 * Cross-backend readers that observe state==OWNED outside the
+			 * lock then see a valid ring_ptr.  Bump generation last so any
+			 * reader that snapped the prior generation will detect the
+			 * change.
+			 */
+			slot->ring_ptr = p;
+			pg_atomic_write_u32(&slot->state, WAIT_EVENT_TRACE_SLOT_OWNED);
+			pg_atomic_fetch_add_u64(&slot->generation, 1);
+			LWLockRelease(&WaitEventTraceCtl->lock);
+
+			my_wait_event_trace = ts;
+			my_trace_proc_number = procNumber;
+
+			/*
+			 * Register cleanup to run BEFORE dsm_backend_shutdown() detaches
+			 * the DSA.  The before_shmem_exit callbacks run in LIFO order
+			 * before DSM detach, so the ORPHANED transition (which does not
+			 * actually free the ring) is safe at that point.
+			 *
+			 * Guarded by shmem_exit_registered because under the
+			 * release-on-disable policy (see wait_event_trace_release_slot
+			 * and assign_wait_event_capture) the allocate branch can run
+			 * multiple times per backend lifetime -- once per off/stats ->
+			 * trace re-enable cycle.  The cleanup itself is idempotent (it
+			 * short-circuits when state is not OWNED), so it is safe to
+			 * invoke after a release-then-reattach cycle, but we still avoid
+			 * growing the before_shmem_exit list.
+			 */
+			if (!shmem_exit_registered)
+			{
+				before_shmem_exit(wait_event_trace_before_shmem_exit,
+								  Int32GetDatum(procNumber));
+				shmem_exit_registered = true;
+			}
+		}
+	}
+	PG_FINALLY();
+	{
+		in_attach = false;
+	}
+	PG_END_TRY();
+}
+
+/*
+ * Free trace ring buffer for this backend on exit.
+ */
+static void
+wait_event_trace_detach(int procNumber)
+{
+	/*
+	 * Only clear local pointers here.  The actual DSA free happens in
+	 * wait_event_trace_before_shmem_exit(), which runs before
+	 * dsm_backend_shutdown() detaches the DSA segments.
+	 */
+	my_wait_event_trace = NULL;
+	my_trace_proc_number = -1;
+}
+
+/*
+ * Release this backend's trace ring buffer back to DSA immediately.
+ *
+ * Called from assign_wait_event_capture when the user steps down from
+ * TRACE to STATS or OFF.  Without this, a ~4 MB ring allocated by a
+ * brief investigation would remain pinned for the rest of the session's
+ * lifetime, which can leak gigabytes across large connection pools.
+ *
+ * Important contrast with wait_event_trace_before_shmem_exit: backend
+ * exit transitions the slot to ORPHANED (preserving data for
+ * cross-backend readers); release_slot fully frees and returns to FREE
+ * because the operator has explicitly disabled trace -- they have
+ * affirmatively decided not to keep the data, so we honour that and
+ * reclaim the memory immediately.  Subsequent re-enable allocates a
+ * fresh ring via wait_event_trace_attach's allocate branch.
+ *
+ * The operation is LWLock-safe and does not raise -- dsa_free is pure
+ * bookkeeping on the DSA freelist, no allocation and no ereport paths.
+ * Safe to call from a GUC assign hook.
+ *
+ * If pg_get_backend_wait_event_trace is currently iterating our own ring
+ * (wait_event_trace_srf_in_progress), we must NOT free the chunk out
+ * from under it: that would be a use-after-free on the records[] the SRF
+ * is still reading.  Set wait_event_trace_release_pending instead and
+ * return; the SRF's PG_FINALLY block will perform the deferred free
+ * after iteration completes.  In practice this branch is unreachable in
+ * current PG (assign hooks fire only at command boundaries and the SRF
+ * is a single command), but it makes the invariant explicit and the
+ * future-proofing free.
+ */
+static void
+wait_event_trace_release_slot(int procNumber)
+{
+	/*
+	 * Re-entrancy guard.  dsa_free takes a DSA-internal LWLock which can in
+	 * principle emit a wait event; if a nested assign hook re-enters we must
+	 * not recurse.  See the function-local-static-bool pattern explainer on
+	 * wait_event_timing_attach_array.
+	 */
+	static bool in_release = false;
+	WaitEventTraceSlot *slot;
+
+	if (in_release)
+		return;
+
+	if (WaitEventTraceCtl == NULL || trace_dsa == NULL)
+		return;
+
+	/*
+	 * Same-backend SRF is iterating our own ring.  Defer the free until the
+	 * SRF's PG_FINALLY runs.
+	 */
+	if (wait_event_trace_srf_in_progress)
+	{
+		wait_event_trace_release_pending = true;
+		return;
+	}
+
+	if (procNumber < 0 || procNumber >= NUM_WAIT_EVENT_TIMING_SLOTS)
+		return;
+
+	slot = &WaitEventTraceCtl->trace_slots[procNumber];
+
+	in_release = true;
+
+	/*
+	 * Disable trace-ring writes on this backend before we touch the lock or
+	 * call dsa_free.  An internal LWLock inside dsa_free can dispatch a wait
+	 * event whose end-timing path would otherwise see capture_level == TRACE
+	 * (the GUC assign hook is in flight; the variable has not been committed
+	 * by the framework yet) and write into the very chunk we are returning to
+	 * the DSA freelist.  See the comment on wait_event_trace_writes_disabled
+	 * for the full UAF analysis.
+	 */
+	wait_event_trace_writes_disabled = true;
+
+	PG_TRY();
+	{
+		LWLockAcquire(&WaitEventTraceCtl->lock, LW_EXCLUSIVE);
+
+		/*
+		 * Drop the local pointer BEFORE the dsa_free as a second line of
+		 * defense (the writes-disabled flag above is the primary gate).  Any
+		 * wait event whose hot path slips past the gate check via a compiler
+		 * or memory-ordering surprise would at least see my_wait_event_trace
+		 * == NULL and skip the write.
+		 */
+		my_wait_event_trace = NULL;
+
+		if (DsaPointerIsValid(slot->ring_ptr))
+		{
+			/*
+			 * Bump generation first to invalidate any concurrent
+			 * cross-backend snapshot, then free, then publish the FREE state
+			 * with a NULL ring_ptr.  Order matters for unlocked readers that
+			 * have already passed the state check.
+			 */
+			pg_atomic_fetch_add_u64(&slot->generation, 1);
+			dsa_free(trace_dsa, slot->ring_ptr);
+			slot->ring_ptr = InvalidDsaPointer;
+			pg_atomic_write_u32(&slot->state, WAIT_EVENT_TRACE_SLOT_FREE);
+		}
+		LWLockRelease(&WaitEventTraceCtl->lock);
+	}
+	PG_FINALLY();
+	{
+		wait_event_trace_writes_disabled = false;
+		in_release = false;
+	}
+	PG_END_TRY();
+}
+
+/*
+ * Clear an orphaned trace ring at backend init time.
+ *
+ * Called from pgstat_set_wait_event_timing_storage() once the new
+ * backend has its procNumber.  If the slot we're inheriting was left
+ * ORPHANED by a previous backend (because we deliberately do not free
+ * trace rings on backend exit -- see the lifecycle discussion on
+ * WaitEventTraceControl), free the ring now so the new backend starts
+ * with a clean FREE slot.  Subsequent wait_event_trace_attach() calls
+ * (when this backend itself enables trace) will then take the
+ * allocate branch.
+ *
+ * No-op when the slot is already FREE or OWNED: FREE means there's
+ * nothing to clear; OWNED is impossible at backend init (only a
+ * not-yet-exited backend can leave a slot OWNED, and procNumbers are
+ * assigned exclusively).  We assert OWNED is not observed in debug
+ * builds and conservatively skip the free in production.
+ *
+ * Robustness: this runs during InitProcess() (before the backend can
+ * accept any work), and the work it performs -- dsa_attach() and
+ * dsa_free() -- can raise ERROR on rare runtime failures (corrupted
+ * DSA segment headers, descriptor exhaustion, mmap ENOMEM, etc.).
+ * An uncaught ERROR here would propagate out of InitProcess() and
+ * abort backend startup entirely, even for sessions that never
+ * intended to use wait_event_capture.  To prevent the trace
+ * feature's housekeeping from gating connection establishment, the
+ * body is wrapped in PG_TRY()/PG_CATCH(): any error from dsa_attach
+ * or dsa_free is captured, downgraded to a WARNING with a hint
+ * pointing at the admin sweep function, and execution continues.
+ * The orphan stays in place; it can be reclaimed by the next
+ * backend that inherits the same procNumber (if the underlying
+ * problem was transient), by pg_stat_clear_orphaned_wait_event_rings(),
+ * or at next cluster restart.
+ */
+static void
+wait_event_trace_clear_orphan_at_init(int procNumber)
+{
+	WaitEventTraceSlot *slot;
+	uint32		state_now;
+	MemoryContext caller_cxt;
+
+	if (WaitEventTraceCtl == NULL)
+		return;
+
+	if (procNumber < 0 || procNumber >= NUM_WAIT_EVENT_TIMING_SLOTS)
+		return;
+
+	slot = &WaitEventTraceCtl->trace_slots[procNumber];
+
+	state_now = pg_atomic_read_u32(&slot->state);
+	if (state_now != WAIT_EVENT_TRACE_SLOT_ORPHANED)
+	{
+		Assert(state_now != WAIT_EVENT_TRACE_SLOT_OWNED);
+		return;
+	}
+
+	/*
+	 * Save CurrentMemoryContext so the PG_CATCH path can copy the error data
+	 * into a context that survives FlushErrorState(). FlushErrorState() calls
+	 * MemoryContextReset(ErrorContext), so CopyErrorData() must run in a
+	 * different context or the returned ErrorData becomes a dangling pointer.
+	 */
+	caller_cxt = CurrentMemoryContext;
+
+	PG_TRY();
+	{
+		/*
+		 * The trace DSA is shared across the cluster.  We must attach to it
+		 * before calling dsa_free (which needs the dsa_area pointer).  The
+		 * DSA was created by some earlier backend that wrote a trace record
+		 * (otherwise the slot couldn't have ended up ORPHANED), so the handle
+		 * in WaitEventTraceCtl is valid; ensure_dsa() will attach.  Both
+		 * ensure_dsa() and dsa_free() can raise ERROR; the PG_CATCH below
+		 * downgrades any such error to a WARNING so backend startup is not
+		 * blocked.
+		 */
+		wait_event_trace_ensure_dsa();
+
+		LWLockAcquire(&WaitEventTraceCtl->lock, LW_EXCLUSIVE);
+		if (pg_atomic_read_u32(&slot->state) == WAIT_EVENT_TRACE_SLOT_ORPHANED &&
+			DsaPointerIsValid(slot->ring_ptr))
+		{
+			pg_atomic_fetch_add_u64(&slot->generation, 1);
+			dsa_free(trace_dsa, slot->ring_ptr);
+			slot->ring_ptr = InvalidDsaPointer;
+			pg_atomic_write_u32(&slot->state, WAIT_EVENT_TRACE_SLOT_FREE);
+		}
+		LWLockRelease(&WaitEventTraceCtl->lock);
+	}
+	PG_CATCH();
+	{
+		ErrorData  *edata;
+
+		/*
+		 * Release any LWLocks we (or anything we called) might still hold.
+		 * Two paths can leave WaitEventTraceCtl->lock held when control
+		 * reaches here:
+		 *
+		 * 1. The outer LWLockAcquire above succeeded and dsa_free raised
+		 * before we reached LWLockRelease. 2. wait_event_trace_ensure_dsa()
+		 * raised inside its own LWLockAcquire/dsa_attach/LWLockRelease
+		 * region.
+		 *
+		 * We are running during InitProcess(), BEFORE any transaction or
+		 * PostgresMain sigsetjmp has been set up, so PG's standard
+		 * "AbortTransaction -> LWLockReleaseAll" cleanup does NOT fire on the
+		 * longjmp into PG_CATCH. Without an explicit release here the lock
+		 * would stay held for the lifetime of this backend, blocking every
+		 * future LW_EXCLUSIVE acquirer (the orphan-clear sweep, release_slot,
+		 * before_shmem_exit transitions, and subsequent backends'
+		 * clear_orphan_at_init).  That would be strictly worse than the
+		 * original failure-startup behavior this commit set out to fix.
+		 *
+		 * LWLockReleaseAll() is the idiomatic catch-path lock cleanup used by
+		 * the standalone aux-process error handlers (walwriter.c,
+		 * checkpointer.c, pgarch.c).  It is safe to call broadly here because
+		 * pgstat_set_wait_ event_timing_storage runs at a fixed point in
+		 * InitProcess where the caller frame holds no other LWLocks across
+		 * our return: the earlier InitProcess steps that touch LWLocks
+		 * (ProcArrayAdd, etc.) release them before returning, and the
+		 * subsequent steps that acquire LWLocks have not yet run.
+		 */
+		LWLockReleaseAll();
+
+		/*
+		 * Switch BACK to the caller's context before CopyErrorData so that
+		 * edata is allocated in a context that survives FlushErrorState().
+		 * FlushErrorState() calls MemoryContextReset(ErrorContext);
+		 * allocating edata in ErrorContext (the default at PG_CATCH entry on
+		 * the error path) would make it a dangling pointer the moment we
+		 * flush.  See the matching pattern in spi.c PG_CATCH branches.
+		 */
+		MemoryContextSwitchTo(caller_cxt);
+		edata = CopyErrorData();
+		FlushErrorState();
+
+		ereport(WARNING,
+				(errcode(edata->sqlerrcode),
+				 errmsg("could not clear orphaned wait-event trace ring "
+						"at backend init: %s", edata->message),
+				 errdetail("Backend startup proceeds with the orphan "
+						   "still allocated for procnumber %d.",
+						   procNumber),
+				 errhint("Run pg_stat_clear_orphaned_wait_event_rings() "
+						 "to release the orphan when the underlying "
+						 "condition is resolved.")));
+
+		FreeErrorData(edata);
+	}
+	PG_END_TRY();
+}
+
+/*
+ * Out-of-line body for pgstat_report_wait_start()'s timing path.  Records
+ * the start timestamp and the event being waited on.  Reached only when
+ * wait_event_capture != OFF.
+ */
+void
+pgstat_report_wait_start_timing(uint32 wait_event_info)
+{
+	/*
+	 * Stay out of the timing path once proc_exit has begun tearing down DSA
+	 * mappings (see the before_shmem_exit callback).
+	 */
+	if (wait_event_timing_writes_disabled)
+		return;
+
+	if (my_wait_event_timing == NULL)
+	{
+		pgstat_wait_event_timing_lazy_attach();
+
+		/*
+		 * lazy_attach can dispatch nested wait events while it sets up DSA
+		 * (dsa_attach takes an internal LWLock); those nested wait_end calls
+		 * clear my_wait_event_info to 0.  Re-publish so the outer wait stays
+		 * visible in pg_stat_activity.  Only needed on the first-attach path.
+		 */
+		*(volatile uint32 *) my_wait_event_info = wait_event_info;
+	}
+
+	if (my_wait_event_timing != NULL)
+	{
+		INSTR_TIME_SET_CURRENT(my_wait_event_timing->wait_start);
+		my_wait_event_timing->current_event = wait_event_info;
+	}
+}
+
+/*
+ * Out-of-line body for pgstat_report_wait_end()'s timing path.  Computes
+ * the wait duration, accumulates per-event statistics, and at the trace
+ * level pushes the completed wait into the per-session ring.
+ *
+ * capture_level is the value of wait_event_capture observed at the inline
+ * gate.  Passing it through (rather than re-loading the global here) avoids
+ * a redundant load on the trace branch below -- the function-call boundary
+ * defeats CSE -- and means a concurrent GUC change cannot half-apply to
+ * this call: we run entirely at the gate's view of the level.
+ */
+void
+pgstat_report_wait_end_timing(int capture_level)
+{
+	uint32		event;
+	uint32		cur_reset_gen;
+
+	if (wait_event_timing_writes_disabled)
+		return;
+
+	if (my_wait_event_timing == NULL)
+	{
+		pgstat_wait_event_timing_lazy_attach();
+		if (my_wait_event_timing == NULL)
+			return;
+	}
+
+	event = my_wait_event_timing->current_event;
+
+	/*
+	 * Service a pending cross-backend reset request.  A single relaxed atomic
+	 * load; when the shared generation has advanced past the value we last
+	 * acted on, clear our own counters on behalf of the requester and record
+	 * the reset.  wait_start is left untouched so the in-flight measurement
+	 * still lands (in the freshly-zeroed counters), and current_event is
+	 * zeroed so external readers do not see stale state.
+	 */
+	cur_reset_gen = pg_atomic_read_u32(&my_wait_event_timing->reset_generation);
+	if (cur_reset_gen != my_last_reset_generation)
+	{
+		memset(my_wait_event_timing->events, 0,
+			   sizeof(my_wait_event_timing->events));
+		lwlock_timing_hash_clear(my_wait_event_timing);
+		my_wait_event_timing->reset_count++;
+		my_wait_event_timing->lwlock_overflow_count = 0;
+		my_wait_event_timing->flat_overflow_count = 0;
+		my_wait_event_timing->current_event = 0;
+		my_last_reset_generation = cur_reset_gen;
+	}
+
+	if (event != 0 && !INSTR_TIME_IS_ZERO(my_wait_event_timing->wait_start))
+	{
+		instr_time	now;
+		int64		duration_ns;
+		int			idx;
+		WaitEventTimingEntry *entry = NULL;
+		bool		warn_lwlock_overflow = false;
+		bool		warn_flat_overflow = false;
+
+		INSTR_TIME_SET_CURRENT(now);
+		duration_ns = INSTR_TIME_GET_NANOSEC(now) -
+			INSTR_TIME_GET_NANOSEC(my_wait_event_timing->wait_start);
+
+		if (duration_ns < 0)
+			duration_ns = 0;
+
+		idx = wait_event_timing_index(event);
+
+		/*
+		 * Single-writer hot path: each slot has exactly one writer (the
+		 * owning backend), and the SRF reader is lock-free, so no locking is
+		 * needed here.  Overflow WARNINGs are deferred to after the
+		 * bookkeeping so ereport() cannot recurse through a wait event while
+		 * counters are in an intermediate state.
+		 */
 		if (idx == WAIT_EVENT_TIMING_IDX_LWLOCK)
 			entry = lwlock_timing_lookup(my_wait_event_timing, event & 0xFFFF);
 		else if (idx >= 0)
